\chapter{Introduction} 
\label{sec:introduction}
{

\section{Laser powder bed fusion of metals}

% Todo:
% check sub and superscripts of u in chapter 2 and section 

% Maybe:
% High-speed plume above laser spot.
% How to choose $\sigma_z$, maybe by surface enthalpy, according to \textcite{Hann2011, King2014}.
% Add some additional text that explains the problem of scales in more detail.
  
\renewcommand\picsDir{chapters/01_introduction_pics}

\Gls*{AM}, also called 3D printing, is a family of methods for automatically producing three-dimensional structures. Unlike subtractive approaches that remove material during manufacturing (such as milling), additive methods successively add material to build the final product. This is typically done in a layerwise fashion, where on each layer, new material is added or consolidated selectively on areas that are inside of the designed structure. As a result, the parts printed using \gls*{AM} techniques are limited in terms of feature size and surface roughness. Before the manufacturing starts, a geometric model must be prepared in a \gls*{CAD} software, where support structures may be added to ensure the mechanical stability of the component and provide sufficient thermal dissipation. The three-dimensional geometric model is then subdivided into thin horizontal slices for layerwise manufacturing. 
The software constructs a path for each slice according to the process parameters that fills the areas inside the geometric model. The structure is then printed using this path, after which several postprocessing steps (e.g., removing support structures) might be necessary \review{to obtain} the final product.  

\begin{figure}[h!]
    \includegraphics[width=\linewidth]{\picsDir/chamber.jpg}
    \caption{Elements of a \acrshort{LPBF} build chamber. \reprintedC}
    \label{fig:introduction:buildchamber} 
\end{figure}

\begin{figure}[h!]
    \includegraphics[width=\linewidth]{\picsDir/ebpbf_structures.jpg}
    \caption{Removal of Ti6Al4V powder around a titanium prosthesis scaffold manufactured by \acrshort{EBPBF}. \reprintedD}
    \label{fig:introduction:titaniummesh} 
\end{figure}

The \textcite{ISO17296} standard defines seven additive manufacturing process categories: vat photopolymerization, material jetting, binder jetting, powder bed fusion, material extrusion, directed energy deposition\review{,} and sheet lamination. These categories vary significantly in their application fields and used materials. Obtaining an overview of all available techniques can be time-consuming as various manufacturers sell their approaches under different names. For example, current entry-level consumer 3D printers often use  \gls*{FFM}, also called \gls*{FDM}, where molten thermoplastic material is deposited through a nozzle. \gls*{FFM}/\gls*{FDM} falls in the category of material extrusion. Similar ideas are used in \gls*{DED} methods for printing metal structures. Instead of directly depositing the material, the metal is supplied as cable or in powder form by an inert gas carrier and melted in place by a high-power laser, an electron beam\review{,} or a plasma arc. This technology allows printing large structures with aeronautics as one major field of application, where it is used to print rocket engine components \parencite{BlakeyMilner2021}, for example. In construction, \gls*{DED} allows printing structural components or even entire bridges, such as the MX3D bridge in Amsterdam \parencite{Buchanan2019}. \Gls*{PBF} methods are an alternative to \gls*{DED} for smaller structures that require more accuracy. Instead of a selective deposition, metal powder is added to the entire layer and then selectively melted by a laser (\glsdisp*{LPBF}{\gls*{LPBF}}) or an electron beam (\glsdisp*{EBPBF}{\gls*{EBPBF}}). Figure~\ref{fig:introduction:buildchamber} shows a typical \gls*{LPBF} build chamber with an active laser. After finishing one layer, the build platform on the right moves downwards by one layer thickness, and the recoater blade on the left supplies new metal powder from the powder supply onto the platform with the partially built structure. Popular application fields of \gls*{PBF} methods besides aerospace engineering are the automotive and medical industries, where high accuracy for smaller parts is essential. Figure~\ref{fig:introduction:titaniummesh} shows a partially submerged titanium prosthesis manufactured with \gls*{EBPBF} and cleaned \review{afterwards}. %\textcite{Megahed2022}
Powder bed fusion is also used with thermoplastic materials in \glsdisp*{LPBFP}{\gls*{LPBFP}} and \glsdisp*{EBPBFP}{\gls*{EBPBFP}}. While this thesis focuses on \gls{LPBF}, many of its challenges exist in other \gls*{PBF} variants that may, therefore, equally benefit from the presented space-time simulation approach.

\begin{figure}[h]
    \centering
    \hspace{1cm}
    \includegraphics[width=0.85\linewidth]{\picsDir/hatching.jpg}
    \caption{Areas on the current layer are hatched if they lie inside the geometric model. \reprintedE}
    \label{fig:introduction:hatching} 
\end{figure}

Printing parts with \gls*{PBF} is a complex process involving many physical phenomena over many spatial and temporal scales. Usually, only a small window of process parameters yields acceptable results, and even within this window, manufacturing failures and defects in the printed objects are common. Therefore, it is crucial to understand the process and develop computational models that allow optimizing the printing process based on the simulation results. A comprehensive discussion of current \gls*{LPBF} technology can be found in~\textcite{Yadroitsev2021}. Current \gls*{LPBF} systems typically use a build chamber of \SIrange{20}{100}{cm} size with a build plate that supports the printed structure. On each new layer of metal powder, a high-power (typically infrared) laser scans the interior of the structure on the current intersection plane using the computer-generated path from the preprocessing stage. Figure~\ref{fig:introduction:hatching} shows two adjacent hatch lines with a sufficient melt pool overlap to avoid pores between them. Afterwards, the build plate is moved downwards by one layer thickness, and a new layer of powder is introduced by the recoating system that ensures a well-leveled surface (using, for example, a leveling roller or blade). Moving the build plate has the advantage that the recoating system and the laser focus plane do not need to move vertically.

\begin{figure}[hbt]
    \hfill
    \includegraphics[width=0.84\linewidth]{\picsDir/keyhole_sketch.jpg}
    \caption{Physical phenomena in and around the melt pool. \reprintedF}
    \label{fig:introduction:phenomena} 
\end{figure}

\begin{figure}[hbt]
    \includegraphics[width=\linewidth]{\picsDir/keyhole_simulation.jpg}
    \caption{High laser powers evaporate metal and push the melt pool surface into the substrate due to recoil pressure. This change in geometry further increases the absorptivity and the melt pool depth, causing keyholes that leave unwanted pores when collapsing. \reprintedG}
    \label{fig:introduction:keyholeporosity} 
\end{figure}

\begin{figure}[h]
    \centering
    \includegraphics[width=0.6\linewidth]{\picsDir/process_window.jpg}
    \hspace{0.5cm}
    \caption{Window of feasible process parameters that result in sufficient fusion without formation of keyholes. \reprintedH}
    \label{fig:introduction:processwindow} 
\end{figure}

When the laser light hits the metal (powder) surface, it is partially reflected and absorbed, converting the radiant energy into heat. With enough laser power, the metal directly around and behind the laser spot is melted for a short time. 
Common laser powers range from below one hundred to a few hundred watts, but different powers can be necessary depending on the width and speed of the laser. The laser intensities in the focus plane are often Gaussian profiles with widths ($4\sigma$) of \SIrange{60}{250}{\micro\meter}. Typical laser velocities range from tens of centimeters per second to over one meter per second. After the laser passes, the metal cools down quickly and solidifies as the heat diffuses into the already-built structure. Figure~\ref{fig:introduction:phenomena} sketches the physical phenomena around a laser beam traveling from left to right. The metal powder surrounding the solidified object has a lower heat conductivity due to its porosity. Outside the melt pool, heat conduction and the induced mechanical response dominate; inside the melt pool, fluid flow and evaporation effects play an important role. The strong temperature gradients towards the laser spot lead to a rapid decrease in density, causing the liquid to expand under the laser spot. The strong density gradients also reduce the surface tension on the liquid-gas interface enough to cause strong Marangoni forces. These are tangential to the liquid surface and point towards regions of higher surface tension, driving the liquid on top of the melt pool away from the laser spot. As a result, circulating flows in the melt pool significantly contribute to convective heat transport \parencite[see, e.g.,][]{Khairallah2016, Egorov2020}. Together with the normal component of the surface tension, the Marangoni forces are one of the primary influences for the surface geometry of the melt pool. Additionally, with high enough laser power, the liquid metal starts to boil, and the evaporation cools the surface while pushing it downwards. This downward force, called recoil pressure, contributes to the formation of a depression in the melt pool. In extreme cases, the deep cavities that can form due to recoil pressure are called keyholes, and the process is said to be in keyhole mode (as opposed to conduction mode), as Figure~\ref{fig:introduction:keyholeporosity} shows.


The highly complex local dynamics in \gls*{LPBF} processes give rise to many potential failures or defects in the final structure. Residual stresses occur when metal locally heats up quickly, expands and compresses nearby material, and cools down again while staying under tension. Depending on the laser path, these residual stresses can \review{induce} cracks or accumulate and deform the printed structure. Other defects in the built structure are pores that can originate from \gls*{LOF} or excessive heat. When the laser power density is too low compared to the laser speed, the energy input onto the substrate surface is insufficient to fully melt the powder layer, resulting in residual pores due to partially melted grains. On the other hand, too much energy input can cause keyholes to periodically collapse with trapped air inside (Figure~\ref{fig:introduction:keyholeporosity}). Figure~\ref{fig:introduction:processwindow} shows the process window of parameters that balance these two extremes. 
However, the conditions during the manufacturing can vary greatly, depending on the part geometry and the selected laser pathing. Closely arranged laser paths and insolating surrounding powder can lead to significant local deviations from the optimal conditions within the process window. The resulting overheating zones can cause dimensional inaccuracies and porosity despite using parameters that perform well in an isolated setting.

\section{The problem of scales in \acrshort{LPBF} simulations}

Computer simulations are essential for understanding and improving \gls*{LPBF} processes. The first step in setting up a simulation is choosing a mathematical model that describes the relevant phenomena in the process. For example, if one is interested in the coarse-scale thermal evolution in \gls*{PBF}, then the local effects in the melt pool do not need to be resolved as long as the energy \review{balance} is correct. The resulting \gls*{PDE} is defined on a spatial domain and usually enforces the conservation of quantities like energy, mass, or momentum. Solutions to such \gls*{PDE}s are functions in space and often time (e.g., the evolution of a temperature field) that are usually hard or impossible to obtain as analytical expressions; however, they can be approximated using numerical methods. These transform the continuously defined \gls*{PDE} into a discrete system of equations that can be solved on a computer and are called discretization methods. In \gls*{LPBF} simulations, it is common to discretize the spatial part using the finite element method and combine it with a finite-difference-based time-stepping scheme. This allows a local refinement of the finite element mesh during each time step towards the current position of the laser. The theoretical background of finite elements and their combination with time-stepping schemes can be found in \textcite{Hughes2000}. The fundamental challenge in simulating \gls*{LPBF} processes is that detailed mathematical models are computationally expensive, and short fractions of the process already require significant resources on current supercomputers. Conversely, models that can be solved for the entire manufacturing process may not capture enough physical effects to gain the desired insight into the process. A review of current simulation models for metal \gls*{AM} can be found in \textcite{Bayat2021}. 

To reliably predict the melt pool dynamics and related effects, such as lack of fusion or keyhole porosity, the fluid flow in the melt pool and the influence of evaporation must be included in the model. Resolving these effects on a scale of a few hundred micrometers over a time span of minutes or hours far exceeds the capabilities of any current simulation framework. However, the thermal evolution can already deliver valuable insights as most phenomena in \gls*{PBF} are driven by heat \review{transfer and distribution}. For example, thermal models can predict melt pool shapes \parencite{Kollmannsberger2019, Paulson2020}, detect local overheating zones \parencite{Ranjan2020}, determine the microstructure formation \parencite{Gu2018, Nitzler2021}, or characterize the mechanical properties of the printed structure \parencite{Xie2021}. The simplicity of thermal models combined with a lower spatial and temporal resolution of the laser spot results in much faster computations compared to higher fidelity models.

Part-scale simulations based on thermal models with time-stepping discretizations are still very challenging and often impossible when fully resolving the laser path without using lumped heat sources (that impose the equivalent heat of an entire line or layer at once).
Classical approaches discretize only the spatial dimensions with finite elements and use a finite-difference scheme to advance the temperature in time. In particular, $hp$-methods can discretize the individual time steps efficiently by locally refining the mesh towards the laser spot ($h$-refinement) while increasing the polynomial degree ($p$-refinement) in regions with a smooth temperature field \parencite{Kollmannsberger2017, Kollmannsberger2021}. Two major challenges exist for developing part-scale time-stepping methods for simulating \gls*{LPBF} processes. First, they are restricted to the same time step length everywhere in space, leading to needlessly high temporal accuracy in regions further away from the laser. Depending on how expensive these peripheral regions are to compute, the cost for one time step may become prohibitively high. Second, efficiently using \gls*{HPC} resources requires sufficiently large problem sizes. However, the simulation of significant parts of the printing process often requires millions of time steps, leaving much less than one second to compute individual time steps. Even if a capable adaptive spatial discretization reduces the computational time to a few seconds on a single CPU, then a single matrix-vector multiplication in the iterative solution of the linear equation system takes only a few milliseconds. For such small problems, the communication overhead makes obtaining good parallel scaling difficult.

%\section{Objectives}

\begin{figure}
    \begin{minipage}[b]{0.49\linewidth} 
        \includeTikz{width=\linewidth}{intro_sketch_timestepping}
        \subcaption{Time-stepping with local refinement in space}
        \label{fig:introduction:comparison1D:timestepping} 
    \end{minipage}%
    \hfill
    \begin{minipage}[b]{0.49\linewidth}
        \includeTikz{width=\linewidth}{intro_sketch_spacetime}
        \subcaption{Locally refined space-time finite elements}
        \label{fig:introduction:comparison1D:spacetime}
    \end{minipage}
    \caption{Discretization method comparison for a transient problem in one spatial dimension with a moving heat source (source path in red, refinement region in dashed green). \reprintedB}
    \label{fig:introduction:comparison1D} 
\end{figure}


\section{Space-time $hp$-finite element discretizations}

This thesis introduces an alternative way of simulating the thermal evolution in \gls*{LPBF} that uses a four-dimensional finite element interpolation for uniformly discretizing space and time. In this setting, elements have three spatial lengths and a duration (the length in time). This allows refining the mesh in the combined four-dimensional space-time, such that finer elements around the laser spot span a shorter duration and coarser elements in the peripheral regions span a longer duration. The simulation duration is subdivided into a sequence of time slabs that are solved consecutively to maintain reasonable problem sizes. This provides the flexibility to increase the sizes of the linear systems originating from individual space-time slabs according to the target environment. While desktop computers benefit from smaller systems that are relatively cheap to compute, large \gls*{HPC} systems may require larger systems to reduce the overall communication overhead. Figures~\ref{fig:introduction:comparison1D}~and~\ref{fig:introduction:slabs2D} demonstrate this idea in one and two space dimensions. Such a method requires a suitable space-time weak formulation that performs well for \gls*{LPBF} applications. As any \gls*{LPBF} process is three-dimensional in space, a capable method for constructing four-dimensional, locally refined $hp$-basis functions is necessary. 
To the author's knowledge, no space-time $hp$-finite element methods have been developed for simulating \gls*{LPBF} processes so far. However, several recent approaches \parencite{Soldner2019, Hodge2021, Cheng2021, Viguerie2021} address the multi-scale nature of the solution by dividing the spatial domain into several subdomains that are integrated with different time step lengths. The continuity across the subdomains is enforced weakly, which allows to develop iterative schemes based on local solutions of the individual problems. Such strategies can reduce the computational effort of integrating peripheral regions in time, resulting in speedups over conventional methods with a uniform time step length. The continuous space-time approach presented herein is compatible in space and time by construction, and heterogeneous time step lengths \review{(i.e., element durations)} are an inherent property of the method. 

%\begin{figure}
%    \includegraphics[width=\linewidth]{\picsDir/introduction_slabs_2D.png}
%    \caption{Three refined space-time slabs for a non-linear heat equation in two spatial dimensions. \reprintedB}
%    \label{fig:introduction:slabs2D} 
%\end{figure}

\begin{figure}
  \centering
  \includeTikz{}{introduction_slabs_2D}
  
  \vspace{-0.6cm}
  \includeTikz{}{colorbar_horizontal}
  \vspace{-0.2cm}
  
  \caption{Three refined space-time slabs for a nonlinear heat equation in two spatial dimensions. \reprintedB}
  \label{fig:introduction:slabs2D} 
\end{figure}

\begin{figure}[h]
  \centering
  \includeTikz{width=0.8\linewidth}{refinement_comparison}%
  \caption{Comparison of refine-by-replacement and refine-by-superposition strategies.}
  \label{fig:introduction:hprefinementcomparison} 
\end{figure}

The standard Bubnov-Galerkin finite element discretization for symmetric problems like Poisson's equation uses the same space for the test and trial functions and results in the best approximation \parencite{Hughes2000}. Unfortunately, this result does not apply to the standard space-time formulation of the heat equation. The first derivative in time leads to an unsymmetric bilinear form with different continuity requirements in the test and trial spaces, rendering it a formulation of Petrov-Galerkin type. The space-time bilinear form does not define an inner product, and the finite element solution is not a projection in a naturally induced (energy) norm. Showing uniform stability and quasi-optimality for pairs of discrete spaces for such Petrov-Galerkin formulations is challenging \parencite{Fuehrer2021}. \Textcite{Steinbach2015} derives optimal convergence estimates of order $p$ for standard continuous finite elements on general space-time meshes, where $p$ is the polynomial degree of the finite elements. They require that the test space contains the trial space, and they later choose the same space for both. They measure the error in a norm that is $H^1$ in space and $L^2$ in time. Initial numerical experiments with the same $C^0$ test and trial spaces show suboptimal convergence rates in the space-time $L^2$-norm for even polynomial degrees and non-local spurious oscillations that travel backward in time in the presence of sharp, underresolved features in the solution. Moreover, a $C^0$ continuous test space does not directly allow the separation of the global space-time problem into consecutive time slabs, which requires a discontinuous test space across certain time slices.

An alternative approach based on a discontinuous test space was introduced by \textcite{Aziz1989}, where the test functions on each temporal interval are polynomials of degree $p - 1$ in time that are not connected across the temporal interfaces. This method leads to optimal convergence in the $L^2$-norm and yields block-triangular systems that can be solved consecutively. Under certain regularity conditions, the method is even superconvergent at the temporal mesh points. The authors also present an equivalent formulation that tests with the time derivative of the trial functions (of degree $p$), which span the same space of piecewise discontinuous polynomials of degree $p - 1$. They suggest that this approach can be used to construct adaptive space-time finite element methods, which is confirmed by the results of this thesis. \Textcite{Schieweck2010} discusses an energy-decreasing property and combines Lagrange interpolations with a Gauss-Lobatto quadrature in time to decouple the linear systems, and \textcite{Hussain2011} investigate suitable efficient parallel solution strategies. A similar space-time formulation for continuous finite element interpolations was developed by \textcite{Devaud2018} and, in particular, \textcite{Langer2019} and \textcite{Langer2020}, who use hierarchical B-Splines to construct an adaptive isogeometric space-time method. \Textcite{Loli2022} add a high-order stabilization term to the isogeometric formulation to obtain a triangular system in time that can be advanced step-wise. \Gls*{DG} methods in time do not force continuity across element interfaces, even in the trial space, and are often used to develop time-stepping schemes that are adaptive in space \parencite{Jamet1978, Eriksson1985}. Due to the reduced continuity, \gls*{DG} approaches lead to more unknowns, rendering them less efficient than continuous methods. 
An overview and comparison of space-time finite element methods for parabolic problems can be found in \textcite{Akrivis2011} and \textcite{Steinbach2019}. Adaptive versions of the continuous and discontinuous Galerkin methods in time that separately refine the spatial and temporal discretizations depending on the error in a chosen quantity of interest were developed by \textcite{Meidner2007} and \textcite{Schmich2008}.

Finite element discretizations that can perform $hp$-refinements are particularly suitable to approximate solutions that are smooth in large parts of the computational domain but have local features that must be resolved. Classical replacement-based $hp$-methods in three dimensions refine by substituting several fine elements in place of an original coarse element (for example, eight fine cubes for one coarse cube). On the resulting incompatible interfaces between coarse and fine elements, called hanging nodes, the shape functions of finer elements must be constrained to the shape functions of the coarse neighbor. In higher dimensions, hanging nodes also refer to incompatible edges, faces, and so on. These constraints already develop complex dependencies in three dimensions \parencite{Demkowicz1989, Demkowicz2006}. The multi-level $hp$-method introduced in \textcite{Zander2015, Zander2016, DiStolfo2016}, and \textcite{Zander2022} simplifies the $hp$-basis construction by keeping the coarse elements in a hierarchical data structure and essentially constructing a high-order finite element basis on the meshes of each refinement level independently. Figure~\ref{fig:introduction:hprefinementcomparison} demonstrates how hanging nodes (nodes and edges) appear when replacing coarse elements and shows the alternative superposition approach followed by the multi-level $hp$-method. There, the treatment of hanging nodes is transformed into a simple deactivation of overlay nodes on the left side. Further refinements are possible by adding more hierarchical overlays with finer elements. The method builds an object-oriented data structure to formulate two simple rules for obtaining linear independent and $C^0$ continuous basis functions that are complete up to a selected polynomial degree on each leaf cell of the refinement tree. While this object-oriented data structure works well in 1D, 2D, and 3D, the number of entities grows exponentially for higher dimensions. In 3D, one refined cube knows about its six faces, twelve edges, eight nodes, and eight child cubes (the fine elements); each face knows about its four edges, four nodes, and four child faces; each edge knows about the two nodes and two child edges; each vertex knows about its child vertex. Additionally, all topological components carry a list of connected elements (cubes) to compare their refinement levels and determine whether the component shall be active or inactive. In four dimensions, one hypercube comprises eight cubes, twenty-four faces, thirty-two edges, and sixteen nodes. Each again carries links to the topological sub-components, children, and adjacent elements. The complexity of constructing and maintaining such a data structure in four dimensions is significant, and efficient implementations with low memory management overhead and favorable memory access patterns become increasingly challenging to develop.

To address the complexity of $hp$-refinements in four dimensions, an even simpler data structure is introduced in this thesis that only stores the direct topological relations between the cells of the refinement tree (cubes in three dimensions or hypercubes in higher dimensions) and not their sub-components (faces, edges, nodes). A consequence of this simplification is that nodes, for example, are not explicitly stored anymore, and one cannot find all connecting elements across a corner of an element by simply reading the list of connected elements of that node. While not explicitly stored, this information still exists implicitly within the list of the neighbors across the $2^d$ interfaces for all elements, where $d$ is the number of dimensions. Therefore, this reduced data structure is complemented by a set of algorithms that construct compatible $p$- and $hp$-basis functions equivalent to the original multi-level $hp$-method by implicitly extracting much of the topological information rather than relying on explicit storage. This is achieved by introducing a \textit{tensor-product mask} and a \textit{location matrix} for each cell of the refinement tree that determines the activation state and the global basis function index of its shape functions and formulating algorithms in terms of operations on the \textit{array slices} of these containers. By repeating these algorithms several times, the information travels across multiple interfaces and reaches, for example, all elements connected to a node. Only the leaves of the refinement tree are considered finite elements, as they form a non-overlapping partition of the computational domain. This view hides the hierarchical nature to allow the use of standard finite element procedures without any modifications. The combination with the aforementioned continuous Petrov-Galerkin formulation leads to a stable and efficient space-time method for simulating \gls*{LPBF} processes.

\section{Outline}

This thesis is structured as follows. Chapter~\ref{sec:formulation} discusses a thermal model with a volumetric heat source (Section~\ref{sec:formulation:laser}) and an apparent heat capacity (Section~\ref{sec:formulation:phasechange}) to consider the latent heat of fusion. The time-stepping method introduced in Section~\ref{sec:formulation:timestepping} uses finite elements to discretize in space and is the reference for evaluating the performance of the space-time finite element method. The presentation of the space-time finite element method is split into three parts, starting with introducing the weak form in the continuous setting in Section~\ref{sec:formulation:spacetime}. Section~\ref{sec:formulation:petrovgalerkin} analyses two formulations with a continuous and a discontinuous test space and compares their performance using two linear benchmark problems. Section~\ref{sec:formulation:linearization} then discusses the solution of the nonlinear equation system arising from a space-time finite element discretization of the nonlinear heat equation. Chapter~\ref{sec:pfem} introduces the essential concepts for constructing $p$-finite element bases for an arbitrary number of dimensions, starting with the necessary topological information of a $p$-finite element mesh in Section~\ref{sec:pfem:mesh}. Section~\ref{sec:pfem:shapefunctions} discusses tensor-products of the integrated Legendre polynomials used as shape functions on each finite element and the construction of the associated tensor-product masks (Section~\ref{sec:pfem:masks}) and location matrices (Section~\ref{sec:pfem:locationmaps}). These contain information on what shape functions are active and what global basis function index they contribute to. Section~\ref{sec:pfem:trunkspace} introduces the construction of trunk space initial tensor-product masks that only keep the essential functions required for completeness. These concepts are then applied to multiple levels of $p$-finite elements in Chapter~\ref{sec:mlhp} to construct $hp$-bases defined on the hierarchical mesh discussed in Section \ref{sec:mlhp:datastructure}. The major difference in the construction of tensor-product masks (Section~\ref{sec:mlhp:masks}) and location matrices (Section~\ref{sec:mlhp:locationmaps}) compared to Chapter~\ref{sec:pfem} is the distinction between internal interfaces and internal boundaries. These concepts are embedded into a standard finite element simulation workflow in Section~\ref{sec:mlhp:workflow}. Sections~\ref{sec:mlhp:lpbfrefinement}~and~\ref{sec:mlhp:slabcompatibility} then introduce an a priori refinement strategy tailored to \gls*{LPBF} processes and the compatible separation of the four-dimensional $hp$-meshes into consecutive time slabs by introducing additional ghost slabs across the initial and final time slices of each slab. The presented approach is applied to several examples in Chapter~\ref{sec:results}. A verification in Section~\ref{sec:results:singular} shows that the multi-level $hp$ extension behaves optimally for a simple Poisson problem. Section~\ref{sec:results:amb} then validates the presented space-time method on the AMB2018 benchmark case. The same setup is used in Section~\ref{sec:results:hatchedsquare} to hatch a square centimeter for about one second and a path length of around one meter. As the last example, Section~\ref{sec:results:comparison} compares the performance of the space-time and time-stepping approaches. Finally, Chapter~\ref{sec:conclusion} summarizes the main results of the thesis and discusses possible future extensions and applications. 

The presented multi-level $hp$ extension was pre-published in \textcite{Kopp2022a}. The content of Section~\ref{sec:formulation:timestepping}, Chapter~\ref{sec:pfem}, Chapter \ref{sec:mlhp} until after Section~\ref{sec:mlhp:workflow}, and Section~\ref{sec:results:singular} is taken from this publication, including literal transcription. Similarly, the application to thermal space-time \gls*{LPBF} simulations was pre-published in \textcite{Kopp2022b}. The content of Chapter~\ref{sec:formulation} without Section~\ref{sec:formulation:timestepping}, Sections~\ref{sec:mlhp:lpbfrefinement}~--~\ref{sec:mlhp:slabcompatibility}, and Sections~\ref{sec:results:amb}~--~\ref{sec:results:hatchedsquare} is taken from this publication, including literal transcription. Footnotes \footnote[1]{The following content is based on \textcite{Kopp2022a}. The main scientific research and its textual elaboration was performed by the author of this work.} and \footnote[2]{The following content is based on \textcite{Kopp2022b}. The main scientific research and its textual elaboration was performed by the author of this work.} reference the respective publications in the concerning sections and mark potential literal transcription. 

% Microstructure
%https://www.youtube.com/watch?v=huvtkdn_keY

}